(load "/Users/hufflen/XML/tacos-plus/basic-operators/launch.scm")

;;;  Handling streams

(define end-of-stream '())
(define end-of-stream? null?)
(define head car)

(define (tail s)
  (force (cdr s)))

(define-syntax delay-cons*
  (syntax-rules (with-applying)
    ((delay-cons* with-applying f1 y) y)
    ((delay-cons* with-applying f1 x x0 ...)
     (cons (f1 x) (delay (delay-cons* with-applying f1 x0 ...))))
    ((delay-cons* y ...) (delay-cons* with-applying values y ...))))

(define s
  (let and-next ((i 0))
    (cons i (delay (and-next (+ i 1))))))

(define s0 (delay-cons* 0 1 2 3 s0))

(define (iter s max-iter-nb)
  (let loop ((s-fast s)
	     (s-slow s)
	     (max-iter-nb-0 max-iter-nb))
    (cond
     ((end-of-stream? s-fast) #f)
     ((zero? max-iter-nb-0) 0)
     ((and (< max-iter-nb-0 max-iter-nb) (eq? s-fast s-slow)) #t)
     (else (let ((s-fast-0 (tail s-fast)))
	     (if (end-of-stream? s-fast-0)
		 #f
		 (loop (tail s-fast-0) (tail s-slow) (- max-iter-nb-0 1))))))))

(define (mk-advance-detect-loop s)
  (let ((s-fast s)
	(s-slow s)
	(advance-slow? #f)
	(loop-detected? #f))
    (lambda (msg)
      (cond ((eq? msg 'ahead)
	     (lambda ()
	       (set! s-fast (tail s-fast))
	       (if advance-slow?
		   (begin
		     (set! s-slow (tail s-slow))
		     (if (eq? s-slow s-fast) (set! loop-detected? #t))
		     (set! advance-slow? #f))
		   (set! advance-slow? #t))
	       s-fast))
	    ((eq? msg 'get) (lambda () s-fast))
	    ((eq? msg 'loop-detected?) (lambda () loop-detected?))))))

(define (iter-plus s max-iter-nb)
  (let* ((advance-s (mk-advance-detect-loop s))
	 (tail-s (advance-s 'ahead))
	 (loop-detected-s (advance-s 'loop-detected?)))
    (let loop ((s-fast ((advance-s 'get)))
	       (max-iter-nb-0 max-iter-nb))
      (cond ((end-of-stream? s-fast) #f)
	    ((zero? max-iter-nb-0) 0)
	    ((loop-detected-s))
	    (else (let ((s-fast-0 (tail-s)))
		    (if (end-of-stream? s-fast-0)
			#f
			(loop (tail-s) (- max-iter-nb-0 1)))))))))

;;;  Second series

(define (mark-false x) (cons x #f))

(define s-plus
  (let and-next ((i 0))
    (cons (mark-false i) (delay (and-next (+ i 1))))))

(define s0-plus (delay-cons* with-applying mark-false 0 1 2 3 s0-plus))

(define (scan s max-iter-nb)
  (if (end-of-stream? s)
      'end
      (let ((the-head (head s)))
	(cond ((cdr the-head) 'loop)
	      ((zero? max-iter-nb) 'dunno)
	      (else (set-cdr! the-head #t)
		    (scan (tail s) (- max-iter-nb 1)))))))
