(load "/Users/hufflen/XML/tacos-plus/basic-operators/launch.scm")

;;;  Operations and file localisation

(define ch-this (ch-mk-ch-this "/Users/hufflen/XML/tacos-plus/new/"))
(define cacheHandler-string "cacheHandler")
(define fileServer2-string "fileServer2")
(define logger-string "logger")

(define (add-cache-handler input-filename output-thunk)
  (and-let* ((output-filename
	      ((ch-add-cp (ch-this (ch-txml-file cacheHandler-string)))
	       input-filename output-thunk)))
    ((ch-add-binding (list "cache" "getCache" cacheHandler-string
			   "requestHandler"))
     output-filename output-thunk)))

(define (add-cache-handler-r input-filename output-thunk)
  (and-let* ((output-filename
	      ((ch-add-cp (ch-this (ch-txml-file cacheHandler-string)))
	       input-filename output-thunk)))
    ((ch-add-binding (list "cache" "getCache" cacheHandler-string
			   "requestHandler"))
     output-filename output-thunk)))

(define (add-file-server input-filename output-thunk)
  (and-let* ((output-filename
	      ((ch-add-cp (ch-this (ch-txml-file fileServer2-string)))
	       input-filename output-thunk)))
    ((ch-add-binding (list "server" "getServer" fileServer2-string
			   "requestDispatcher"))
     output-filename output-thunk)))

(define (add-logger input-filename output-thunk)
  (and-let* ((output-filename
	      ((ch-add-cp (ch-this (ch-txml-file logger-string)))
	       input-filename output-thunk)))
    ((ch-add-binding (list "log" "getLog" "logger" "requestAnalyzer"))
     output-filename output-thunk)))

(define delete-file-server (ch-remove-cp fileServer2-string))

(define duration-validity-up
  (ch-att-up cacheHandler-string "ValidityDuration"))

(define memory-size-up (ch-att-up cacheHandler-string "sizeMemory"))
(define remove-cache-handler (ch-remove-cp cacheHandler-string))
(define remove-logger (ch-remove-cp logger-string))

(define f2-alist (list (cons add-cache-handler add-cache-handler-r)))

;;;  Handling streams

(define end-of-stream '())
(define end-of-stream? null?)
(define head car)

(define (tail s)
  (force (cdr s)))

(define-syntax delay-cons*
  (syntax-rules (with-applying)
    ((delay-cons* with-applying f1 y) y)
    ((delay-cons* with-applying f1 x x0 ...)
     (cons (f1 x) (delay (delay-cons* with-applying f1 x0 ...))))
    ((delay-cons* y ...) (delay-cons* with-applying values y ...))))

;;;  Utilities for checking paths.

(define (ceiling-even n)
  (if (even? n) n (+ n 1)))

(define (detect-loop? after-beginning? path-loop? path-fast path-slow s)
  (or path-loop? (and after-beginning? (eq? path-fast path-slow)
		      (begin
			(writeln-all #f s)
			#t))))
