(load "/Users/hufflen/XML/tacos-plus/new/new.scm")

;;;  Interface with XQuery

(define ch-mk-xq-input
  (let ((xq-suffix ".xq"))
    (lambda (dirname-0)
      (lambda (xq-input) (string-append dirname-0 xq-input xq-suffix)))))

(define ch-check-xq-input
  (ch-mk-xq-input "/Users/hufflen/XML/tacos-plus/new/"))

(define ch-mk-xq-launcher
  (let ((filename-string "filename"))
    (lambda (xq-id-string)
      (let ((xq-input-filename (ch-check-xq-input xq-id-string)))
	(lambda (input-filename)
	  (let ((output-filename (np-mk-tmp-filename)))
	    (and-let* (((ext-xqueryproc xq-input-filename output-filename
					(cons filename-string
					      (ch-txml-file input-filename))))
		       (result (ext-extract-boolean output-filename)))
	      (car result))))))))

(define ch-ac (ch-mk-xq-launcher "ac"))

;;;  Marking streams

(define (mark-false x)
  (cons x #f))

;;;  Path examples

(define path-aa
  (delay-cons* with-applying mark-false values remove-cache-handler 
	       add-cache-handler memory-size-up values delete-file-server
	       duration-validity-up add-file-server end-of-stream))

(define path-ab
  (delay-cons* with-applying mark-false values remove-cache-handler 
	       add-cache-handler memory-size-up values delete-file-server
	       duration-validity-up add-file-server path-ab))

(define infinite-path-aa
  (delay-cons* with-applying mark-false values remove-cache-handler 
	       add-cache-handler
	       (this memory-size-up-ff 
		     (delay-cons* with-applying mark-false memory-size-up
				  values delete-file-server
				  duration-validity-up add-file-server
				  memory-size-up-ff))))

(define loop-detected-string "Path loop detected.")

(define (display-loop-detected) (writeln-all #t loop-detected-string) #t)

(define (check-after! f2 check-f)
  (lambda (path-fast path-slow filename output-thunk max-iter-nb)
    (let ((advance-before-cps
	   (lambda (path-fast-0 filename-0 k2 after-k2)
	     (let* ((the-head (head path-fast-0))
		    (head-f2 (car the-head))
		    (filename-1 (head-f2 filename-0 output-thunk))
		    (path-fast-1 (tail path-fast-0)))
	       (if (eq? head-f2 f2)
		   (after-k2 path-fast-1 filename-1)
		   (k2 path-fast-1 filename-1))))))
      (let loop-before ((path-fast-0 path-fast)
			(path-slow-0 path-slow)
			(filename-0 filename)
			(max-iter-nb-0 (ceiling-even max-iter-nb)))
	(cond
	 ((end-of-stream? path-fast-0) #t)
	 ((zero? max-iter-nb-0) (list path-fast-0 filename-0))
	 ((and (< max-iter-nb-0 max-iter-nb) (eq? path-fast-0 path-slow-0))
	  (display-loop-detected))
	 (else
	  (advance-before-cps
	   path-fast-0 filename-0
	   (lambda (path-fast-1 filename-1)
	     (if (end-of-stream? path-fast-1)
		 #t
		 (advance-before-cps path-fast-1 filename-1
				     (lambda (path-fast-2 filename-2) 
				       (loop-before path-fast-2 
						    (tail path-slow-0)
						    filename-2
						    (- max-iter-nb-0 2)))
				     (lambda (path-fast-2 filename-2)
				       (check-f path-fast-2 (tail path-slow-0)
						filename-2 output-thunk
						max-iter-nb-0)))))
	   (lambda (path-fast-1 filename-1)
	     (check-f path-fast-1 (tail path-slow-0) filename-1 output-thunk
		      max-iter-nb-0)))))))))

(define (check-always! xq-f1)
  (lambda (path-fast path-slow filename output-thunk max-iter-nb)
    (let ((advance-after-cps
	   (lambda (head-0 tail-0 filename-0 k2)
	     (let ((filename-1 ((car head-0) filename-0 output-thunk)))
	       (and (xq-f1 filename-1)
		    (begin
		      (set-cdr! head-0 #t)
		      (k2 tail-0 filename-1)))))))
      (and (xq-f1 filename)
	   (let loop ((path-fast-0 path-fast)
		      (path-slow-0 path-slow)
		      (path-loop? #f)
		      (after-beginning? #f)
		      (filename-0 filename) 
		      (max-iter-nb-0 (ceiling-even max-iter-nb)))
	(cond
	 ((end-of-stream? path-fast-0) #t)
	 ((zero? max-iter-nb-0) (list path-fast-0 filename-0))
	 (else
	  (let* ((path-loop-0?
		  (detect-loop? after-beginning? path-loop? path-fast-0
				path-slow-0 loop-detected-string))
		 (the-head (head path-fast-0)))
	    (or (and path-loop-0? (cdr the-head))
		(advance-after-cps
		 the-head (tail path-fast-0) filename-0
		 (lambda (path-fast-1 filename-1)
		   (if (end-of-stream? path-fast-1)
		       #t
		       (advance-after-cps (head path-fast-1) (tail path-fast-1)
					  filename-1
					  (lambda (path-fast-2 filename-2)
					    (loop (tail path-fast-1)
						  (tail path-slow-0)
						  path-loop-0? #t filename-2
						  (- max-iter-nb-0
						     2))))))))))))))))

(define (check check-on-path-f5 path)
  (lambda (filename max-iter-nb)
    (if (not ((log-output-p-pv 'get))) ((log-output-p-pv 'screen)))
    (let ((filename-0 (ch-this filename)))
      (check-on-path-f5 path path filename-0 ((ch-file 'new) filename-0) 
			(ceiling-even max-iter-nb)))))

(define check-after-add-cache-handler-always-ch-ac
  (check-after! add-cache-handler (check-always! ch-ac)))

(define test-finite-path
  (check check-after-add-cache-handler-always-ch-ac path-aa))

(define test-sb-false
  (check check-after-add-cache-handler-always-ch-ac path-ab))

(define test-infinite-path
  (check check-after-add-cache-handler-always-ch-ac infinite-path-aa))

(define (run-test-finite-path)
  (test-finite-path "Server" 200))

(define (run-test-sb-false)
  (test-sb-false "Server" 200))

(define (run-test-infinite-path)
  (test-infinite-path "Server" 200))
