(load "/Users/hufflen/XML/tacos-plus/new/new.scm")

;;;  "Intelligent" "tail" function.

(define (mk-advance-detect-loop s msg)
  (let ((s-fast s)
	(s-slow s)
	(advance-slow? #f)
	(loop-detected? #f))
    (lambda (msg-0)
      (cond ((eq? msg-0 'ahead)
	     (lambda ()
	       (set! s-fast (tail s-fast))
	       (if advance-slow?
		   (begin
		     (set! s-slow (tail s-slow))
		     (if (eq? s-slow s-fast) (set! loop-detected? #t))
		     (set! advance-slow? #f))
		   (set! advance-slow? #t))
	       s-fast))
	    ((eq? msg-0 'get) (lambda () s-fast))
	    ((eq? msg-0 'loop-detected?)
	     (lambda ()
	       (if loop-detected? (writeln-all #f msg))
	       loop-detected?))))))

;;;  Path examples

(define path-a
  (delay-cons* values remove-cache-handler add-cache-handler memory-size-up
	       values delete-file-server duration-validity-up add-file-server
	       end-of-stream))

(define path-r
  (delay-cons* values remove-cache-handler remove-logger add-cache-handler-r
	       memory-size-up values delete-file-server duration-validity-up
	       add-file-server add-logger end-of-stream))

(define f2-alist (list (cons add-cache-handler add-cache-handler-r)))

(define infinite-path-a
  (delay-cons* values
	       (this remove-cache-handler-ff
		     (delay-cons* remove-cache-handler add-cache-handler
				  memory-size-up values delete-file-server
				  duration-validity-up add-file-server
				  remove-cache-handler-ff))))

(define infinite-path-r
  (delay-cons* values remove-cache-handler remove-logger
	       (this add-cache-handler-r-ff 
		     (delay-cons* add-cache-handler-r memory-size-up values
				  delete-file-server duration-validity-up
				  add-file-server add-logger
				  remove-cache-handler remove-logger
				  add-cache-handler-r-ff))))

(define infinite-path-r0
  (delay-cons* values remove-cache-handler remove-logger add-cache-handler-r 
	       memory-size-up values delete-file-server duration-validity-up
	       add-file-server
	       (this add-logger-ff-loop
		     (delay-cons* add-logger remove-logger
				  add-logger-ff-loop))))

(define paths-check
  (let* ((common-substring " path loop detected.")
	 (abstract-m (string-append "Abstract" common-substring))
	 (refined-m (string-append "Refined" common-substring))
	 (tau-m (string-append "Tau" common-substring))
	 (tau-found-string "Finding a 'tau' transition.")
	 (display-tau-found (lambda () (writeln-all #f tau-found-string))))
    (lambda (path-a path-r f2-alist-0)
      (lambda (filename-a filename-r max-iter-nb)
	(if (not ((log-output-p-pv 'get))) ((log-output-p-pv 'screen)))
	(let* ((advance-a-f (mk-advance-detect-loop path-a abstract-m))
	       (advance-r-f (mk-advance-detect-loop path-r refined-m))
	       (tail-a-f (advance-a-f 'ahead))
	       (tail-r-f (advance-r-f 'ahead))
	       (loop-detected-a-f? (advance-a-f 'loop-detected?))
	       (loop-detected-r-f? (advance-r-f 'loop-detected?))
	       (end-up (lambda (filename-a filename-r)
			 (list advance-a-f filename-a advance-r-f filename-r)))
	       (detect-loop-plus? (lambda (path-loop? loop-detected-thunk?) 
				    (or path-loop? (loop-detected-thunk?))))
	       (filename-a0 (ch-this filename-a))
	       (filename-r0 (ch-this filename-r))
	       (output-thunk-a ((ch-file 'new) filename-a0))
	       (output-thunk-r ((ch-file 'new) filename-r0))
	       (max-iter-nb-0 (ceiling-even max-iter-nb))
	       (check-end-cps
		(lambda (path-a-fast path-r-fast r-k0 both-k0)
		  (cond
		   ((end-of-stream? path-r-fast) (end-of-stream? path-a-fast))
		   ((end-of-stream? path-a-fast) (r-k0))
		   (else (both-k0)))))
	       (loop-r-only
		(lambda (filename-a path-r-fast path-r-loop? filename-r
				    max-iter-nb-1)
		  (let loop-r ((path-r0-fast path-r-fast)
			       (path-r0-loop? path-r-loop?) 
			       (filename-r0 filename-r)
			       (max-iter-nb-2 max-iter-nb-1))
		    (cond 
		     (path-r0-loop? #f)
		     ((zero? max-iter-nb-2) (end-up filename-a filename-r0))
		     (else
		      (let ((head-r-f2 (head path-r0-fast)))
			(if (rassoc-plus head-r-f2 f2-alist-0 eq?)
			    #f
			    (begin 
			      (display-tau-found)
			      (let ((filename-r1
				     (head-r-f2 filename-r0 output-thunk-r)))
				(and (ch-rfd-by filename-a filename-r1)
				     (let ((path-r1-fast (tail-r-f)))
				       (or (end-of-stream? path-r1-fast)
					   (loop-r path-r1-fast
						   (loop-detected-r-f?)
						   filename-r1
						   (- max-iter-nb-2
						      1))))))))))))))
	       (advance-both-cps
		(lambda (path-a-fast filename-a path-r-fast filename-r
				     advance-r-tau-mark-0 k5)
		  (let ((head-a-f2 (head path-a-fast)) 
			(head-r-f2 (head path-r-fast)))
		    (if (or (eq? head-r-f2 head-a-f2)
			    (and-let* ((association
					(rassoc-plus head-r-f2 f2-alist-0
						     eq?)))
			      (eq? (car association) head-a-f2)))
			(let ((filename-a0
			       (head-a-f2 filename-a output-thunk-a))
			      (filename-r0
			       (head-r-f2 filename-r output-thunk-r)))
			  (and (ch-rfd-by filename-a0 filename-r0)
			       (k5 (tail-a-f) filename-a0 (tail-r-f) 
				   filename-r0 #f)))
			(begin
			  (display-tau-found)
			  (let ((filename-r0
				 (head-r-f2 filename-r output-thunk-r)))
			    (and (ch-rfd-by filename-a filename-r0)
				 (k5 path-a-fast filename-a (tail-r-f) 
				     filename-r0
				     (let ((advance-r-tau-mark-1
					    (or advance-r-tau-mark-0
						(mk-advance-detect-loop
						 path-r-fast tau-m))))
				       ((advance-r-tau-mark-1 'ahead))
				       advance-r-tau-mark-1))))))))))
	  (let loop ((path-a0-fast path-a) 
		     (path-a-loop? #f)
		     (filename-a1 filename-a0)
		     (path-r0-fast path-r)
		     (path-r-loop? #f)
		     (filename-r1 filename-r0)
		     (advance-r-tau-mark #f)
		     (max-iter-nb-1 max-iter-nb-0))
	    (check-end-cps
	     path-a0-fast path-r0-fast
	     (lambda ()
	       (loop-r-only filename-a1 path-r0-fast path-r-loop? filename-r1 
			    max-iter-nb-1))
	     (lambda ()
	       (if (zero? max-iter-nb-1)
		   (end-up filename-a1 filename-r1)
		   (if (and advance-r-tau-mark
			    ((advance-r-tau-mark 'loop-detected?)))
		       #f
		       (let ((path-a0-loop?
			      (detect-loop-plus? path-a-loop?
						 loop-detected-a-f?))
			     (path-r0-loop?
			      (detect-loop-plus? path-r-loop?
						 loop-detected-r-f?)))
			 (advance-both-cps
			  path-a0-fast filename-a1 path-r0-fast filename-r1
			  advance-r-tau-mark
			  (lambda (path-a1-fast filename-a2 path-r1-fast
						filename-r2
						advance-r-tau-mark-0)
			    (or (and path-a0-loop? path-r0-loop?) 
				(check-end-cps
				 path-a1-fast path-r1-fast
				 (lambda () 
				   (loop-r-only filename-a2 path-r1-fast
						path-r0-loop? filename-r2
						max-iter-nb-1))
				 (lambda ()
				   (advance-both-cps 
				    path-a1-fast filename-a2 path-r1-fast
				    filename-r2 advance-r-tau-mark-0
				    (lambda (path-a2-fast filename-a3 
							  path-r2-fast
							  filename-r3
							  advance-r-tau-mark-1)
				      (loop path-a2-fast path-a0-loop?
					    filename-a3 path-r2-fast 
					    path-r0-loop? filename-r3
					    advance-r-tau-mark-1
					    (- max-iter-nb-1
					       2))))))))))))))))))))

(define test-finite-paths (paths-check path-a path-r f2-alist))

(define test-infinite-paths
  (paths-check infinite-path-a infinite-path-r f2-alist))

(define test-infinite-paths-0
  (paths-check infinite-path-a infinite-path-r0 f2-alist))

(define (run-test-finite-paths)
  (test-finite-paths "Server" "ServerRaffine" 200))

(define (run-test-infinite-paths)
  (test-infinite-paths "Server" "ServerRaffine" 200))

(define (run-test-infinite-paths-0)
  (test-infinite-paths-0 "Server" "ServerRaffine" 200))
